import { interfaces } from "inversify";
import * as helperInterfaces from "./interfaces";
declare function register(kernel: interfaces.Kernel): <T>(identifier: string | symbol | interfaces.Newable<T> | interfaces.Abstract<T>, dependencies?: (string | symbol | interfaces.Newable<any> | interfaces.Abstract<any> | helperInterfaces.BasicInjection | helperInterfaces.NamedInjection | helperInterfaces.TaggedInjection)[], constraint?: (binding: interfaces.BindingInWhenOnSyntax<T>) => void) => (constructor: interfaces.Newable<T>) => void;
declare function registerSelf(kernel: interfaces.Kernel): <T>(dependencies?: (string | symbol | interfaces.Newable<any> | interfaces.Abstract<any> | helperInterfaces.BasicInjection | helperInterfaces.NamedInjection | helperInterfaces.TaggedInjection)[], constraint?: (binding: interfaces.BindingInWhenOnSyntax<T>) => void) => (constructor: interfaces.Newable<T>) => void;
declare function registerConstructor(kernel: interfaces.Kernel): <T>(identifier: string | symbol | interfaces.Newable<T> | interfaces.Abstract<T>, constraint?: (binding: interfaces.BindingWhenOnSyntax<T>) => void) => (constructor: interfaces.Newable<T>) => void;
declare function registerConstantValue(kernel: interfaces.Kernel): <T>(identifier: string | symbol | interfaces.Newable<T> | interfaces.Abstract<T>, value: T, constraint?: (binding: interfaces.BindingWhenOnSyntax<T>) => void) => void;
declare function registerDynamicValue(kernel: interfaces.Kernel): <T>(identifier: string | symbol | interfaces.Newable<T> | interfaces.Abstract<T>, func: (context: interfaces.Context) => T, constraint?: (binding: interfaces.BindingInWhenOnSyntax<T>) => void) => void;
declare function registerFunction(kernel: interfaces.Kernel): <T extends Function>(identifier: string | symbol | interfaces.Newable<T> | interfaces.Abstract<T>, func: T, constraint?: (binding: interfaces.BindingWhenOnSyntax<T>) => void) => void;
declare function registerAutoFactory(kernel: interfaces.Kernel): <T1, T2>(factoryIdentifier: string | symbol | interfaces.Newable<T1> | interfaces.Abstract<T1>, serviceIdentifier: string | symbol | interfaces.Newable<T2> | interfaces.Abstract<T2>, constraint?: (binding: interfaces.BindingWhenOnSyntax<T1>) => void) => void;
declare function registerFactory(kernel: interfaces.Kernel): <T1, T2>(identifier: string | symbol | interfaces.Newable<T1> | interfaces.Abstract<T1>, factory: interfaces.FactoryCreator<T2>, constraint?: (binding: interfaces.BindingWhenOnSyntax<T1>) => void) => void;
declare function registerProvider(kernel: interfaces.Kernel): <T1, T2>(identifier: string | symbol | interfaces.Newable<T1> | interfaces.Abstract<T1>, provider: interfaces.ProviderCreator<T2>, constraint?: (binding: interfaces.BindingWhenOnSyntax<T1>) => void) => void;
export { register, registerSelf, registerConstantValue, registerDynamicValue, registerConstructor, registerFunction, registerAutoFactory, registerFactory, registerProvider };
