import { decorate, injectable, inject, tagged, named } from "inversify";
function annotate(constructor, dependencies) {
    if (dependencies === void 0) { dependencies = []; }
    decorate(injectable(), constructor);
    (dependencies).forEach(function (injection, index) {
        if (injection.type === undefined) {
            decorate(inject(injection), constructor, index);
        }
        else {
            decorate(inject(injection.type), constructor, index);
            if (injection.named !== undefined) {
                decorate(named(injection.named), constructor, index);
            }
            if (injection.tagged !== undefined) {
                decorate(tagged(injection.tagged.key, injection.tagged.value), constructor, index);
            }
        }
    });
}
export default annotate;
